<?php

namespace HCM\FPA\ObrigacaoLegal\Dirf\Registros;

use HCM\FPA\Registro\FPARegistro;

class RegistroDIRF extends FPARegistro{

    const REGISTRO_DIRF = 'DIRF';
    const REGISTRO_RESPO = 'RESPO';
    const REGISTRO_DECPJ = 'DECPJ';

    const IDE_LEIAUTE_DIRF = 'IDE_LEIAUTE_DIRF';

    private $_anoReferencia;
    private $_anoCalendario;
    private $_idTipoDeclarac;
    private $_nrRecibo;
    private $_ideLeiaute;

    public function geraRegistro($tpRegistro, $tpInscricao=null, $nrInscricao=null){
        $this->_geraRegistro(self::REGISTRO_DIRF);
    }

    public function geraRegistroDIRF(){
        $this->_geraRegistro(self::REGISTRO_DIRF);
    }

    private function _geraRegistro($tpRegistro){
        // Ordem 1
        $this->atribuiDadoDirf($tpRegistro);

        // Ordem 2
        $this->atribuiDadoDirf($this->_anoReferencia);

        // Ordem 3
        $this->atribuiDadoDirf($this->_anoCalendario);

        // Ordem 4
        $this->atribuiDadoDirf($this->_idTipoDeclarac);

        // Ordem 5
        $this->atribuiDadoDirf($this->_nrRecibo);

        // Ordem 6
        $this->atribuiDadoDirf($this->_ideLeiaute);
    }

    public function setAnoReferencia($anoReferencia){
        $this->_anoReferencia = $anoReferencia;
    }
    public function setAnoCalendario($anoCalendario){
        $this->_anoCalendario = $anoCalendario;
    }
    public function setIdTipoDeclarac($idTipoDeclarac){
        $this->_idTipoDeclarac = $idTipoDeclarac;
    }
    public function setNrRecibo($nrRecibo){
        $this->_nrRecibo = $nrRecibo;
    }
    public function setIdeLeiaute($ideLeiaute){
        $this->_ideLeiaute = $ideLeiaute;
    }

}