<?php
namespace HCM\Geral\Services\Queue;

use Zeedhi\Queue\Connection;
use HCM\Util\HCMParameters;

class HCMProducerService extends \Zeedhi\Queue\Producer {

    // apollo port browser = 61680

    const LIMITE_LOTE = 5;

    protected static $queueName = "/queue/";
    protected $hcmParameters;

    public function __construct(Connection $connection, HCMParameters $hcmParameters) {
        parent::__construct($connection);
        $this->hcmParameters = $hcmParameters;
    }

    public function sendCalculo($calculoParams)
    {
        self::$queueName .= 'hcm_calculo_'.$this->hcmParameters->getNrorgTrabalho();

        $count    = 0;
        $vinculos = [];
        $params   = $calculoParams;

        // verifica se o total de vinculos é supeior ao limite, caso contrário manda o lote do jeito que chega
        if (count($calculoParams["VINCULOS"]) > self::LIMITE_LOTE) {
            foreach ($calculoParams["VINCULOS"] as $key => $vinculo) {                        
                if ($count < self::LIMITE_LOTE) {
                    $vinculos[$key] = $vinculo;
                    $count++;
                } else {
                    $params["VINCULOS"] = $vinculos;
                    $message = json_encode(array(
                            'CALCULO_PARAMS' => array(
                                $params
                            )
                        )
                    );

                    $this->send($message);
                    $vinculos = [];
                    $vinculos[$key] = $vinculo; // o vinculo que faz entrar no 'else' não é contemplado no array, então zeramos adicionando ele para o próximo
                    $count = 1; // como adicionamos o vínculo acima, o contador deve iniciar com zero.
                }            
            }
        } else {
            $vinculos = $calculoParams["VINCULOS"];
        }

        if (count($vinculos) > 0) {
            $params["VINCULOS"] = $vinculos;
            $message = json_encode(array(
                                'CALCULO_PARAMS' => array(
                                    $params
                                )
                            )
                        );

            $this->send($message);
        }        
    }
}