<?php
/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 30/10/13
 * Time: 08:43
 * To change this template use File | Settings | File Templates.
 */

namespace Folha\Exceptions;


class FeriasCalculo extends \Exception {

    public static function quantidadeDiasGozoInvalida(\GpevinculomEntity $vinculo = null, \FpaferiasEntity $ferias = null)
    {
        $msg = 'Quantidade de dias de gozo em férias inválida';
        if ($vinculo && $ferias) {
            $dtiniaquisicao = reset(explode(' ', $ferias->getDtiniaquisicao()));
            $dtfimaquisicao = reset(explode(' ', $ferias->getDtfimaquisicao()));
            $msg = <<<PHP
<pre>
{$msg}:
    Vínculo: {$vinculo->getNrvinculom()} {$vinculo->getNmvinculom()}
    Ferias: {$ferias->getNrferias()} {$dtiniaquisicao} - {$dtfimaquisicao}
    Quantidade de dias máximo de férias {$ferias->getQtdiasmaxfe()}
</pre>
PHP;
        }
        throw new self($msg, 1);
    }

    public static function vinculoSemFerias(\GpevinculomEntity $vinculo = null)
    {

        $msg = 'Vínculo sem férias';
        if ($vinculo) {
            $msg = <<<PHP
<pre>
{$msg}:
    Vínculo: {$vinculo->getNrvinculom()} {$vinculo->getNmvinculom()}
</pre>
PHP;
        }
        throw new self($msg, 2);
    }

}